org.apache.solr.client.solrj.impl

## Class LBHttpSolrClient

- java.lang.Object
- - org.apache.solr.client.solrj.SolrClient
  - - org.apache.solr.client.solrj.impl.LBHttpSolrClient

All Implemented Interfaces:
  Closeable, Serializable, AutoCloseable

    public class LBHttpSolrClient
    extends SolrClient

LBHttpSolrClient or "LoadBalanced HttpSolrClient" is a load balancing wrapper around `HttpSolrClient`. This is useful when you have multiple Solr servers and the requests need to be Load Balanced among them. Do NOT use this class for indexing in master/slave scenarios since documents must be sent to the correct master; no inter-node routing is done. In SolrCloud (leader/replica) scenarios, it is usually better to use `CloudSolrClient`, but this class may be used for updates because the server will forward them to the appropriate leader.

It offers automatic failover when a server goes down and it detects when the server comes back up.

Load balancing is done using a simple round-robin on the list of servers.

If a request to a server fails by an IOException due to a connection timeout or read timeout then the host is taken off the list of live servers and moved to a 'dead server list' and the request is resent to the next live server. This process is continued till it tries all the live servers. If at least one server is alive, the request succeeds, and if not it fails.

>      SolrClient lbHttpSolrClient = new LBHttpSolrClient("http://host1:8080/solr/", "http://host2:8080/solr", "http://host2:8080/solr");
>      //or if you wish to pass the HttpClient do as follows
>      httpClient httpClient = new HttpClient();
>      SolrClient lbHttpSolrClient = new LBHttpSolrClient(httpClient, "http://host1:8080/solr/", "http://host2:8080/solr", "http://host2:8080/solr");

This detects if a dead server comes alive automatically. The check is done in fixed intervals in a dedicated thread. This interval can be set using `setAliveCheckInterval(int)` , the default is set to one minute.

When to use this?
This can be used as a software load balancer when you do not wish to setup an external load balancer. Alternatives to this code are to use a dedicated hardware load balancer or using Apache httpd with mod_proxy_balancer as a load balancer. See Load balancing on Wikipedia

Since:
  solr 1.4
See Also:
  Serialized Form

### Nested Class Summary

Nested Classes
`static class` `LBHttpSolrClient.Builder` Constructs `LBHttpSolrClient` instances from provided configuration.
`static class` `LBHttpSolrClient.Req`
`static class` `LBHttpSolrClient.Rsp`
`protected static class` `LBHttpSolrClient.ServerWrapper`

### Field Summary

Fields
`protected Map<String,LBHttpSolrClient.ServerWrapper>` `zombieServers`

### Constructor Summary

Constructors
Constructor and Description
`LBHttpSolrClient(org.apache.http.client.HttpClient httpClient, ResponseParser parser, String... solrServerUrl)` Deprecated. use `LBHttpSolrClient.Builder` instead. This will soon be a protected method and will only be available for use in implementing subclasses.
`LBHttpSolrClient(org.apache.http.client.HttpClient httpClient, String... solrServerUrl)` Deprecated. use `LBHttpSolrClient.Builder` instead.
`LBHttpSolrClient(String... solrServerUrls)` Deprecated. use `LBHttpSolrClient.Builder` instead.

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`void` `addQueryParams(String queryOnlyParam)`
`void` `addSolrServer(String server)`
`protected Exception` `addZombie(HttpSolrClient server, Exception e)`
`void` `close()`
`protected Exception` `doRequest(HttpSolrClient client, LBHttpSolrClient.Req req, LBHttpSolrClient.Rsp rsp, boolean isUpdate, boolean isZombie, String zombieKey)`
`protected void` `finalize()`
`org.apache.http.client.HttpClient` `getHttpClient()` Return the HttpClient this instance uses.
`ResponseParser` `getParser()`
`Set<String>` `getQueryParams()`
`RequestWriter` `getRequestWriter()`
`protected HttpSolrClient` `makeSolrClient(String server)`
`static String` `normalize(String server)`
`String` `removeSolrServer(String server)`
`LBHttpSolrClient.Rsp` `request(LBHttpSolrClient.Req req)` Tries to query a live server from the list provided in Req.
`NamedList<Object>` `request(SolrRequest request, String collection)` Tries to query a live server.
`void` `setAliveCheckInterval(int interval)` LBHttpSolrServer keeps pinging the dead servers at fixed interval to find if it is alive.
`void` `setConnectionTimeout(int timeout)`
`void` `setParser(ResponseParser parser)` Changes the `ResponseParser` that will be used for the internal SolrServer objects.
`void` `setQueryParams(Set<String> queryParams)` Expert Method.
`void` `setRequestWriter(RequestWriter requestWriter)` Changes the `RequestWriter` that will be used for the internal SolrServer objects.
`void` `setSoTimeout(int timeout)` set soTimeout (read timeout) on the underlying HttpConnectionManager.

### Methods inherited from class org.apache.solr.client.solrj.SolrClient

`add, add, add, add, add, add, add, add, add, add, addBean, addBean, addBean, addBean, addBeans, addBeans, addBeans, addBeans, addBeans, addBeans, commit, commit, commit, commit, commit, commit, deleteById, deleteById, deleteById, deleteById, deleteById, deleteById, deleteById, deleteById, deleteByQuery, deleteByQuery, deleteByQuery, deleteByQuery, getBinder, getById, getById, getById, getById, getById, getById, getById, getById, optimize, optimize, optimize, optimize, optimize, optimize, ping, query, query, query, query, queryAndStreamResponse, queryAndStreamResponse, request, rollback, rollback`

### Methods inherited from class java.lang.Object

`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### zombieServers

    protected final Map<String,LBHttpSolrClient.ServerWrapper> zombieServers

### Constructor Detail

#### LBHttpSolrClient

    @Deprecated
    public LBHttpSolrClient(String... solrServerUrls)
                                 throws MalformedURLException

Deprecated. use `LBHttpSolrClient.Builder` instead.

Throws:
  `MalformedURLException`

#### LBHttpSolrClient

    @Deprecated
    public LBHttpSolrClient(org.apache.http.client.HttpClient httpClient,
                                        String... solrServerUrl)

Deprecated. use `LBHttpSolrClient.Builder` instead.
The provided httpClient should use a multi-threaded connection manager

#### LBHttpSolrClient

    @Deprecated
    public LBHttpSolrClient(org.apache.http.client.HttpClient httpClient,
                                        ResponseParser parser,
                                        String... solrServerUrl)

Deprecated. use `LBHttpSolrClient.Builder` instead. This will soon be a protected method and will only be available for use in implementing subclasses.
The provided httpClient should use a multi-threaded connection manager

### Method Detail

#### getQueryParams

    public Set<String> getQueryParams()

#### setQueryParams

    public void setQueryParams(Set<String> queryParams)

Expert Method.

Parameters:
  `queryParams` - set of param keys to only send via the query string

#### addQueryParams

    public void addQueryParams(String queryOnlyParam)

#### normalize

    public static String normalize(String server)

#### makeSolrClient

    protected HttpSolrClient makeSolrClient(String server)

#### request

    public LBHttpSolrClient.Rsp request(LBHttpSolrClient.Req req)
                                 throws SolrServerException,
                                        IOException

Tries to query a live server from the list provided in Req. Servers in the dead pool are skipped. If a request fails due to an IOException, the server is moved to the dead pool for a certain period of time, or until a test request on that server succeeds. Servers are queried in the exact order given (except servers currently in the dead pool are skipped). If no live servers from the provided list remain to be tried, a number of previously skipped dead servers will be tried. Req.getNumDeadServersToTry() controls how many dead servers will be tried. If no live servers are found a SolrServerException is thrown.

Parameters:
  `req` - contains both the request as well as the list of servers to query
Returns:
  the result of the request
Throws:
  `IOException` - If there is a low-level I/O error.
  `SolrServerException`

#### addZombie

    protected Exception addZombie(HttpSolrClient server,
                                  Exception e)

#### doRequest

    protected Exception doRequest(HttpSolrClient client,
                                  LBHttpSolrClient.Req req,
                                  LBHttpSolrClient.Rsp rsp,
                                  boolean isUpdate,
                                  boolean isZombie,
                                  String zombieKey)
                           throws SolrServerException,
                                  IOException

Throws:
  `SolrServerException`
  `IOException`

#### addSolrServer

    public void addSolrServer(String server)
                       throws MalformedURLException

Throws:
  `MalformedURLException`

#### removeSolrServer

    public String removeSolrServer(String server)

#### setConnectionTimeout

    public void setConnectionTimeout(int timeout)

#### setSoTimeout

    public void setSoTimeout(int timeout)

set soTimeout (read timeout) on the underlying HttpConnectionManager. This is desirable for queries, but probably not for indexing.

#### close

    public void close()

#### request

    public NamedList<Object> request(SolrRequest request,
                                     String collection)
                              throws SolrServerException,
                                     IOException

Tries to query a live server. A SolrServerException is thrown if all servers are dead. If the request failed due to IOException then the live server is moved to dead pool and the request is retried on another live server. After live servers are exhausted, any servers previously marked as dead will be tried before failing the request.

Specified by:
  `request` in class `SolrClient`
Parameters:
  `request` - the SolrRequest.
  `collection` - the collection to execute the request against
Returns:
  response
Throws:
  `IOException` - If there is a low-level I/O error.
  `SolrServerException` - if there is an error on the server

#### setAliveCheckInterval

    public void setAliveCheckInterval(int interval)

LBHttpSolrServer keeps pinging the dead servers at fixed interval to find if it is alive. Use this to set that interval

Parameters:
  `interval` - time in milliseconds

#### getHttpClient

    public org.apache.http.client.HttpClient getHttpClient()

Return the HttpClient this instance uses.

#### getParser

    public ResponseParser getParser()

#### setParser

    public void setParser(ResponseParser parser)

Changes the `ResponseParser` that will be used for the internal SolrServer objects.

Parameters:
  `parser` - Default Response Parser chosen to parse the response if the parser were not specified as part of the request.
See Also:
  `SolrRequest.getResponseParser()`

#### setRequestWriter

    public void setRequestWriter(RequestWriter requestWriter)

Changes the `RequestWriter` that will be used for the internal SolrServer objects.

Parameters:
  `requestWriter` - Default RequestWriter, used to encode requests sent to the server.

#### getRequestWriter

    public RequestWriter getRequestWriter()

#### finalize

    protected void finalize()
                     throws Throwable

Overrides:
  `finalize` in class `Object`
Throws:
  `Throwable`